#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>

#include "peteys_tmpl_lib.h"

#define MAX_VAR 10000
#define MAX_LL 100000

#include "agf_types.h"

int main(int argc, char **argv) {
  char *outfile;
  char *vecfile;
  char *clsfile;

  char *command;

  FILE *ifs;
  FILE *ofs1, *ofs2;
  FILE *rf;

  dim_ta nvar;
  real_a vec[MAX_VAR];
  cls_ta cls;
  dim_ta ind, ind2;
  int err;

  char line[MAX_LL];
  int pos;
  int rel;

  char c;
  int rflag=0;
  int hflag=0;

  int errcode=0;

  while ((c = getopt(argc, argv, "Rh")) != -1) {
    switch (c) {
      case ('R'):
             rflag=1;
	     break;
      case ('h'):
             hflag=1;
	     break;
      case ('?'):
             fprintf(stderr, "Unknown option: -%c -- ignored\n", optopt);
	     errcode=10;
	     break;
      default:
	     fprintf(stderr, "Error parsing command line\n");
	     exit(21);
    }
  }

  argc-=optind;
  argv+=optind;

  if (argc < 1 || hflag) {
    printf("Converts class training data in LIBSVM compatible ascii format\n");
    printf("to libAGF compatible binary format.\n\n");
    printf("usage: svm2agf2 [infile] basename\n\n");
    printf("    where:\n");
    printf("infile   = name of ASCII input file\n");
    printf("basename = base name of binary output files:\n");
    printf("           .vec for vector data, .cls for class data\n");
    exit(1);
  }

  if (argc==1) {
    if (rflag) {
      ifs=stdin;
    } else {
      command=new char [strlen(argv[0])+30];
      sprintf(command, "svm_remove_multiclass | svm2agf -R %s", argv[0]);
      return system(command);
    }
    outfile=argv[0];
  } else {
    if (rflag) {
      ifs=fopen(argv[0], "r");
    } else {
      command=new char [strlen(argv[0])+25];
      sprintf(command, "svm_remove_multiclass %s", argv[0]);
      ifs=popen(command, "r");
    }
    outfile=argv[1];
  }

  //generate the output file names:
  vecfile=new char[strlen(outfile)+5];
  strcpy(vecfile, outfile);
  strcat(vecfile, ".vec");

  clsfile=new char[strlen(outfile)+5];
  strcpy(clsfile, outfile);
  strcat(clsfile, ".cls");

  fgets(line, MAX_LL, ifs);
  //printf("%s", line);

  sscanf(line, "%d%d%n", &cls, &ind2, &pos);
  nvar=ind;

  while (pos<MAX_LL) {
    for (pos=pos; line[pos]!=':'; pos++);
    pos++;
    err=sscanf(line+pos, "%g%d%n", vec+ind2-1, &ind, &rel);
    //printf("nscan=%d, vec[%d]=%g, ind=%d, pos=%d, rel=%d\n", err, ind2-1, vec[ind2-1], ind, pos, rel);
    if (err < 2) break;
    if (ind > nvar) nvar=ind;
    ind2=ind;
    pos+=rel;
  }

  ofs1=fopen(vecfile, "w");
  fwrite(&nvar, sizeof(nvar), 1, ofs1);
  fwrite(vec, sizeof(real_a), nvar, ofs1);

  ofs2=fopen(clsfile, "w");
  fwrite(&cls, sizeof(cls), 1, ofs2);

  while (feof(ifs)==0) {
    if (fgets(line, MAX_LL, ifs)==NULL) break;
    //printf("%s", line);

    sscanf(line, "%d%d%n", &cls, &ind2, &pos);

    if (rflag==0)

    while (pos<MAX_LL) {
      for (pos=pos; line[pos]!=':'; pos++);
      pos++;
      err=sscanf(line+pos, "%g%d%n", vec+ind2-1, &ind, &rel);
      //printf("2: nscan=%d\n", err);
      if (err < 2) break;
      ind2=ind;
      pos+=rel;
    }

    fwrite(vec, sizeof(real_a), nvar, ofs1);
    fwrite(&cls, sizeof(cls_ta), 1, ofs2);
  }


  if (rflag) {
    fclose(ifs);
  } else {
    pclose(ifs);
  } 
  fclose(ofs1);
  fclose(ofs2);

  return errcode;

}

