#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>

#include "agf_types.h"

//dirt simple, removes multi-class labels and creates duplicate line
#define MAXLL 10000
#define MAXNDUP 100

int main (int argc, char **argv) {
  char line[MAXLL];
  cls_ta cls[MAXNDUP];
  cls_ta ndup;

  int pos;
  int pos2;
  int rel;

  FILE *infs;
  FILE *outfs;

  char c;
  int hflag=0;

  int errcode=0;

  while ((c = getopt(argc, argv, "Rh")) != -1) {
    switch (c) {
      case ('h'):
             hflag=1;
	     break;
      case ('?'):
             fprintf(stderr, "Unknown option: -%c -- ignored\n", optopt);
	     errcode=10;
	     break;
      default:
	     fprintf(stderr, "Error parsing command line\n");
	     exit(21);
    }
  }

  argc-=optind;
  argv+=optind;

  if (hflag) {
    printf("Removes multi-class labels from LIBSVM files and converts them to\n");
    printf("to duplicate entries.\n\n");
    printf("usage: svm_remove_multiclass [-h] [infile [outfile]]\n\n");
    printf("    where:\n");
    printf("infile   = input file\n");
    printf("outfile  = output file:\n");
    printf("-h       = print this help screen\n");
    exit(1);
  }

  if (argc==0) {
    infs=stdin;
    outfs=stdout;
  } else if (argc==1) {
    infs=fopen(argv[0], "r");
    outfs=stdout;
  } else {
    infs=fopen(argv[0], "r");
    outfs=fopen(argv[1], "w");
  }

  while (feof(infs)==0) {
    fgets(line, MAXLL, infs);
    ndup=0;
    sscanf(line, "%d%n", cls+ndup, &pos);
    while (pos < MAXLL) {
      for (pos2=pos ;line[pos2]<='9' && line[pos2]>='0'; pos2++);
      if (line[pos2]==',') {
        pos=pos2+1; 
	ndup++;
      } else {
        pos++;
        break;
      }
      sscanf(line+pos, "%d%n", cls+ndup, &rel);
      pos+=rel;
    }
    for (int i=0; i<=ndup; i++) fprintf(outfs, "%d %s", cls[i], line+pos);
  }

  fclose(infs);
  fclose(outfs);

  return errcode;

}

